<?php
use PoP\Hooks\Facades\HooksAPIFacade;
use PoP\ComponentModel\ModuleProcessors\AbstractModuleProcessor;

class PoP_Categories_Module_Processor_CustomFilterInners extends AbstractModuleProcessor
{
    public const MODULE_FILTERINNER_CATEGORIES = 'filterinner-categories';
    public const MODULE_FILTERINNER_CATEGORYCOUNT = 'filterinner-categorycount';

    public function getModulesToProcess(): array
    {
        return array(
            [self::class, self::MODULE_FILTERINNER_CATEGORIES],
            [self::class, self::MODULE_FILTERINNER_CATEGORYCOUNT],
        );
    }

    public function getSubmodules(array $module): array
    {
        $ret = parent::getSubmodules($module);

        $inputmodules = [
            self::MODULE_FILTERINNER_CATEGORIES => [
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_SEARCH],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_ORDER],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_LIMIT],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_OFFSET],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_IDS],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_ID],
            ],
            self::MODULE_FILTERINNER_CATEGORYCOUNT => [
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_SEARCH],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_IDS],
                [PoP_Module_Processor_FilterInputs::class, PoP_Module_Processor_FilterInputs::MODULE_FILTERINPUT_ID],
            ],
        ];
        if ($modules = HooksAPIFacade::getInstance()->applyFilters(
            'Categories:FilterInners:inputmodules',
            $inputmodules[$module[1]],
            $module
        )) {
            $ret = array_merge(
                $ret,
                $modules
            );
        }
        return $ret;
    }
}



