<?php

declare(strict_types=1);

namespace PoP\EmojiDefinitions;

use PoP\Definitions\DefinitionResolverInterface;

class DefinitionResolver implements DefinitionResolverInterface
{
    /**
     * @var array<string, int>
     */
    private array $definition_counters = [];
    /**
     * @var string[]
     */
    private array $emojis = [
        '😀',
        '😁',
        '😂',
        '🤣',
        '😃',
        '😄',
        '😅',
        '😆',
        '😉',
        '😊',
        '😋',
        '😎',
        '😍',
        '😘',
        '🥰',
        '😗',
        '😙',
        '😚',
        '☺️',
        '🙂',
        '🤗',
        '🤩',
        '🤔',
        '🤨',
        '😐',
        '😑',
        '😶',
        '🙄',
        '😏',
        '😣',
        '😥',
        '😮',
        '🤐',
        '😯',
        '😪',
        '😫',
        '😴',
        '😌',
        '😛',
        '😜',
        '😝',
        '🤤',
        '😒',
        '😓',
        '😔',
        '😕',
        '🙃',
        '🤑',
        '😲',
        '☹️',
        '🙁',
        '😖',
        '😞',
        '😟',
        '😤',
        '😢',
        '😭',
        '😦',
        '😧',
        '😨',
        '😩',
        '🤯',
        '😬',
        '😰',
        '😱',
        '🥵',
        '🥶',
        '😳',
        '🤪',
        '😵',
        '😡',
        '😠',
        '🤬',
        '😷',
        '🤒',
        '🤕',
        '🤢',
        '🤮',
        '🤧',
        '😇',
        '🤠',
        '🤡',
        '🥳',
        '🥴',
        '🥺',
        '🤥',
        '🤫',
        '🤭',
        '🧐',
        '🤓',
        '😈',
        '👿',
        '👹',
        '👺',
        '💀',
        '👻',
        '👽',
        '🤖',
        '💩',
        '😺',
        '😸',
        '😹',
        '😻',
        '😼',
        '😽',
        '🙀',
        '😿',
        '😾',
        '👶',
        '👧',
        '🧒',
        '👦',
        '👩',
        '🧑',
        '👨',
        '👵',
        '🧓',
        '👴',
        '👲',
        '👳‍♀️',
        '👳‍♂️',
        '🧕',
        '🧔',
        '👱‍♂️',
        '👱‍♀️',
        '👨‍🦰',
        '👩‍🦰',
        '👨‍🦱',
        '👩‍🦱',
        '👨‍🦲',
        '👩‍🦲',
        '👨‍🦳',
        '👩‍🦳',
        '🦸‍♀️',
        '🦸‍♂️',
        '🦹‍♀️',
        '🦹‍♂️',
        '👮‍♀️',
        '👮‍♂️',
        '👷‍♀️',
        '👷‍♂️',
        '💂‍♀️',
        '💂‍♂️',
        '🕵️‍♀️',
        '🕵️‍♂️',
        '👩‍⚕️',
        '👨‍⚕️',
        '👩‍🌾',
        '👨‍🌾',
        '👩‍🍳',
        '👨‍🍳',
        '👩‍🎓',
        '👨‍🎓',
        '👩‍🎤',
        '👨‍🎤',
        '👩‍🏫',
        '👨‍🏫',
        '👩‍🏭',
        '👨‍🏭',
        '👩‍💻',
        '👨‍💻',
        '👩‍💼',
        '👨‍💼',
        '👩‍🔧',
        '👨‍🔧',
        '👩‍🔬',
        '👨‍🔬',
        '👩‍🎨',
        '👨‍🎨',
        '👩‍🚒',
        '👨‍🚒',
        '👩‍✈️',
        '👨‍✈️',
        '👩‍🚀',
        '👨‍🚀',
        '👩‍⚖️',
        '👨‍⚖️',
        '👰',
        '🤵',
        '👸',
        '🤴',
        '🤶',
        '🎅',
        '🧙‍♀️',
        '🧙‍♂️',
        '🧝‍♀️',
        '🧝‍♂️',
        '🧛‍♀️',
        '🧛‍♂️',
        '🧟‍♀️',
        '🧟‍♂️',
        '🧞‍♀️',
        '🧞‍♂️',
        '🧜‍♀️',
        '🧜‍♂️',
        '🧚‍♀️',
        '🧚‍♂️',
        '👼',
        '🤰',
        '🤱',
        '🙇‍♀️',
        '🙇‍♂️',
        '💁‍♀️',
        '💁‍♂️',
        '🙅‍♀️',
        '🙅‍♂️',
        '🙆‍♀️',
        '🙆‍♂️',
        '🙋‍♀️',
        '🙋‍♂️',
        '🤦‍♀️',
        '🤦‍♂️',
        '🤷‍♀️',
        '🤷‍♂️',
        '🙎‍♀️',
        '🙎‍♂️',
        '🙍‍♀️',
        '🙍‍♂️',
        '💇‍♀️',
        '💇‍♂️',
        '💆‍♀️',
        '💆‍♂️',
        '🧖‍♀️',
        '🧖‍♂️',
        '💅',
        '🤳',
        '💃',
        '🕺',
        '👯‍♀️',
        '👯‍♂️',
        '🕴',
        '🚶‍♀️',
        '🚶‍♂️',
        '🏃‍♀️',
        '🏃‍♂️',
        '👫',
        '👭',
        '👬',
        '💑',
        '👩‍❤️‍👩',
        '👨‍❤️‍👨',
        '💏',
        '👩‍❤️‍💋‍👩',
        '👨‍❤️‍💋‍👨',
        '👪',
        '👨‍👩‍👧',
        '👨‍👩‍👧‍👦',
        '👨‍👩‍👦‍👦',
        '👨‍👩‍👧‍👧',
        '👩‍👩‍👦',
        '👩‍👩‍👧',
        '👩‍👩‍👧‍👦',
        '👩‍👩‍👦‍👦',
        '👩‍👩‍👧‍👧',
        '👨‍👨‍👦',
        '👨‍👨‍👧',
        '👨‍👨‍👧‍👦',
        '👨‍👨‍👦‍👦',
        '👨‍👨‍👧‍👧',
        '👩‍👦',
        '👩‍👧',
        '👩‍👧‍👦',
        '👩‍👦‍👦',
        '👩‍👧‍👧',
        '👨‍👦',
        '👨‍👧',
        '👨‍👧‍👦',
        '👨‍👦‍👦',
        '👨‍👧‍👧',
        '🤲',
        '👐',
        '🙌',
        '👏',
        '🤝',
        '👍',
        '👎',
        '👊',
        '✊',
        '🤛',
        '🤜',
        '🤞',
        '✌️',
        '🤟',
        '🤘',
        '👌',
        '👈',
        '👉',
        '👆',
        '👇',
        '☝️',
        '✋',
        '🤚',
        '🖐',
        '🖖',
        '👋',
        '🤙',
        '💪',
        '🦵',
        '🦶',
        '🖕',
        '✍️',
        '🙏',
        '💍',
        '💄',
        '💋',
        '👄',
        '👅',
        '👂',
        '👃',
        '👣',
        '👁',
        '👀',
        '🧠',
        '🦴',
        '🦷',
        '🗣',
        '👤',
        '👥',
        '🧥',
        '👚',
        '👕',
        '👖',
        '👔',
        '👗',
        '👙',
        '👘',
        '👠',
        '👡',
        '👢',
        '👞',
        '👟',
        '🥾',
        '🥿',
        '🧦',
        '🧤',
        '🧣',
        '🎩',
        '🧢',
        '👒',
        '🎓',
        '⛑',
        '👑',
        '👝',
        '👛',
        '👜',
        '💼',
        '🎒',
        '👓',
        '🕶',
        '🥽',
        '🥼',
        '🌂',
        '🧵',
        '🧶',
        '👱',
        '👳',
        '👮',
        '👷',
        '💂',
        '🕵',
        '🙇',
        '💁',
        '🙅',
        '🙆',
        '🙋',
        '🤦',
        '🤷',
        '🙎',
        '🙍',
        '💇',
        '💆',
        '🚶',
        '🏃',
        '🐶',
        '🐱',
        '🐭',
        '🐹',
        '🐰',
        '🦊',
        '🦝',
        '🐻',
        '🐼',
        '🦘',
        '🦡',
        '🐨',
        '🐯',
        '🦁',
        '🐮',
        '🐷',
        '🐽',
        '🐸',
        '🐵',
        '🙈',
        '🙉',
        '🙊',
        '🐒',
        '🐔',
        '🐧',
        '🐦',
        '🐤',
        '🐣',
        '🐥',
        '🦆',
        '🦢',
        '🦅',
        '🦉',
        '🦚',
        '🦜',
        '🦇',
        '🐺',
        '🐗',
        '🐴',
        '🦄',
        '🐝',
        '🐛',
        '🦋',
        '🐌',
        '🐚',
        '🐞',
        '🐜',
        '🦗',
        '🕷',
        '🕸',
        '🦂',
        '🦟',
        '🦠',
        '🐢',
        '🐍',
        '🦎',
        '🦖',
        '🦕',
        '🐙',
        '🦑',
        '🦐',
        '🦀',
        '🐡',
        '🐠',
        '🐟',
        '🐬',
        '🐳',
        '🐋',
        '🦈',
        '🐊',
        '🐅',
        '🐆',
        '🦓',
        '🦍',
        '🐘',
        '🦏',
        '🦛',
        '🐪',
        '🐫',
        '🦙',
        '🦒',
        '🐃',
        '🐂',
        '🐄',
        '🐎',
        '🐖',
        '🐏',
        '🐑',
        '🐐',
        '🦌',
        '🐕',
        '🐩',
        '🐈',
        '🐓',
        '🦃',
        '🕊',
        '🐇',
        '🐁',
        '🐀',
        '🐿',
        '🦔',
        '🐾',
        '🐉',
        '🐲',
        '🌵',
        '🎄',
        '🌲',
        '🌳',
        '🌴',
        '🌱',
        '🌿',
        '☘️',
        '🍀',
        '🎍',
        '🎋',
        '🍃',
        '🍂',
        '🍁',
        '🍄',
        '🌾',
        '💐',
        '🌷',
        '🌹',
        '🥀',
        '🌺',
        '🌸',
        '🌼',
        '🌻',
        '🌞',
        '🌝',
        '🌛',
        '🌜',
        '🌚',
        '🌕',
        '🌖',
        '🌗',
        '🌘',
        '🌑',
        '🌒',
        '🌓',
        '🌔',
        '🌙',
        '🌎',
        '🌍',
        '🌏',
        '💫',
        '⭐️',
        '🌟',
        '✨',
        '⚡️',
        '☄️',
        '💥',
        '🔥',
        '🌪',
        '🌈',
        '☀️',
        '🌤',
        '⛅️',
        '🌥',
        '☁️',
        '🌦',
        '🌧',
        '⛈',
        '🌩',
        '🌨',
        '❄️',
        '☃️',
        '⛄️',
        '🌬',
        '💨',
        '💧',
        '💦',
        '☔️',
        '☂️',
        '🌊',
        '🌫',
        '🍏',
        '🍎',
        '🍐',
        '🍊',
        '🍋',
        '🍌',
        '🍉',
        '🍇',
        '🍓',
        '🍈',
        '🍒',
        '🍑',
        '🍍',
        '🥭',
        '🥥',
        '🥝',
        '🍅',
        '🍆',
        '🥑',
        '🥦',
        '🥒',
        '🥬',
        '🌶',
        '🌽',
        '🥕',
        '🥔',
        '🍠',
        '🥐',
        '🍞',
        '🥖',
        '🥨',
        '🥯',
        '🧀',
        '🥚',
        '🍳',
        '🥞',
        '🥓',
        '🥩',
        '🍗',
        '🍖',
        '🌭',
        '🍔',
        '🍟',
        '🍕',
        '🥪',
        '🥙',
        '🌮',
        '🌯',
        '🥗',
        '🥘',
        '🥫',
        '🍝',
        '🍜',
        '🍲',
        '🍛',
        '🍣',
        '🍱',
        '🥟',
        '🍤',
        '🍙',
        '🍚',
        '🍘',
        '🍥',
        '🥮',
        '🥠',
        '🍢',
        '🍡',
        '🍧',
        '🍨',
        '🍦',
        '🥧',
        '🍰',
        '🎂',
        '🍮',
        '🍭',
        '🍬',
        '🍫',
        '🍿',
        '🧂',
        '🍩',
        '🍪',
        '🌰',
        '🥜',
        '🍯',
        '🥛',
        '🍼',
        '☕️',
        '🍵',
        '🥤',
        '🍶',
        '🍺',
        '🍻',
        '🥂',
        '🍷',
        '🥃',
        '🍸',
        '🍹',
        '🍾',
        '🥄',
        '🍴',
        '🍽',
        '🥣',
        '🥡',
        '🥢',
        '⚽️',
        '🏀',
        '🏈',
        '⚾️',
        '🥎',
        '🏐',
        '🏉',
        '🎾',
        '🥏',
        '🎱',
        '🏓',
        '🏸',
        '🥅',
        '🏒',
        '🏑',
        '🥍',
        '🏏',
        '⛳️',
        '🏹',
        '🎣',
        '🥊',
        '🥋',
        '🎽',
        '⛸',
        '🥌',
        '🛷',
        '🛹',
        '🎿',
        '⛷',
        '🏂',
        '🏋️‍♀️',
        '🏋',
        '🏋️‍♂️',
        '🤼‍♀️',
        '🤼‍♂️',
        '🤸‍♀️',
        '🤸',
        '🤸‍♂️',
        '⛹️‍♀️',
        '⛹',
        '⛹️‍♂️',
        '🤺',
        '🤾‍♀️',
        '🤾',
        '🤾‍♂️',
        '🏌️‍♀️',
        '🏌',
        '🏌️‍♂️',
        '🏇',
        '🧘‍♀️',
        '🧘',
        '🧘‍♂️',
        '🏄‍♀️',
        '🏄',
        '🏄‍♂️',
        '🏊‍♀️',
        '🏊',
        '🏊‍♂️',
        '🤽‍♀️',
        '🤽',
        '🤽‍♂️',
        '🚣‍♀️',
        '🚣',
        '🚣‍♂️',
        '🧗‍♀️',
        '🧗',
        '🧗‍♂️',
        '🚵‍♀️',
        '🚵',
        '🚵‍♂️',
        '🚴‍♀️',
        '🚴',
        '🚴‍♂️',
        '🏆',
        '🥇',
        '🥈',
        '🥉',
        '🏅',
        '🎖',
        '🏵',
        '🎗',
        '🎫',
        '🎟',
        '🎪',
        '🤹‍♀️',
        '🤹',
        '🤹‍♂️',
        '🎭',
        '🎨',
        '🎬',
        '🎤',
        '🎧',
        '🎼',
        '🎹',
        '🥁',
        '🎷',
        '🎺',
        '🎸',
        '🎻',
        '🎲',
        '🧩',
        '♟',
        '🎯',
        '🎳',
        '🎮',
        '🎰',
        '🚗',
        '🚕',
        '🚙',
        '🚌',
        '🚎',
        '🏎',
        '🚓',
        '🚑',
        '🚒',
        '🚐',
        '🚚',
        '🚛',
        '🚜',
        '🛴',
        '🚲',
        '🛵',
        '🏍',
        '🚨',
        '🚔',
        '🚍',
        '🚘',
        '🚖',
        '🚡',
        '🚠',
        '🚟',
        '🚃',
        '🚋',
        '🚞',
        '🚝',
        '🚄',
        '🚅',
        '🚈',
        '🚂',
        '🚆',
        '🚇',
        '🚊',
        '🚉',
        '✈️',
        '🛫',
        '🛬',
        '🛩',
        '💺',
        '🛰',
        '🚀',
        '🛸',
        '🚁',
        '🛶',
        '⛵️',
        '🚤',
        '🛥',
        '🛳',
        '⛴',
        '🚢',
        '⚓️',
        '⛽️',
        '🚧',
        '🚦',
        '🚥',
        '🚏',
        '🗺',
        '🗿',
        '🗽',
        '🗼',
        '🏰',
        '🏯',
        '🏟',
        '🎡',
        '🎢',
        '🎠',
        '⛲️',
        '⛱',
        '🏖',
        '🏝',
        '🏜',
        '🌋',
        '⛰',
        '🏔',
        '🗻',
        '🏕',
        '⛺️',
        '🏠',
        '🏡',
        '🏘',
        '🏚',
        '🏗',
        '🏭',
        '🏢',
        '🏬',
        '🏣',
        '🏤',
        '🏥',
        '🏦',
        '🏨',
        '🏪',
        '🏫',
        '🏩',
        '💒',
        '🏛',
        '⛪️',
        '🕌',
        '🕍',
        '🕋',
        '⛩',
        '🛤',
        '🛣',
        '🗾',
        '🎑',
        '🏞',
        '🌅',
        '🌄',
        '🌠',
        '🎇',
        '🎆',
        '🌇',
        '🌆',
        '🏙',
        '🌃',
        '🌌',
        '🌉',
        '🌁',
        '🆓',
        '📗',
        '📕',
        '⌚️',
        '📱',
        '📲',
        '💻',
        '⌨️',
        '🖥',
        '🖨',
        '🖱',
        '🖲',
        '🕹',
        '🗜',
        '💽',
        '💾',
        '💿',
        '📀',
        '📼',
        '📷',
        '📸',
        '📹',
        '🎥',
        '📽',
        '🎞',
        '📞',
        '☎️',
        '📟',
        '📠',
        '📺',
        '📻',
        '🎙',
        '🎚',
        '🎛',
        '⏱',
        '⏲',
        '⏰',
        '🕰',
        '⌛️',
        '⏳',
        '📡',
        '🔋',
        '🔌',
        '💡',
        '🔦',
        '🕯',
        '🗑',
        '🛢',
        '💸',
        '💵',
        '💴',
        '💶',
        '💷',
        '💰',
        '💳',
        '🧾',
        '💎',
        '⚖️',
        '🔧',
        '🔨',
        '⚒',
        '🛠',
        '⛏',
        '🔩',
        '⚙️',
        '⛓',
        '🔫',
        '💣',
        '🔪',
        '🗡',
        '⚔️',
        '🛡',
        '🚬',
        '⚰️',
        '⚱️',
        '🏺',
        '🧭',
        '🧱',
        '🔮',
        '🧿',
        '🧸',
        '📿',
        '💈',
        '⚗️',
        '🔭',
        '🧰',
        '🧲',
        '🧪',
        '🧫',
        '🧬',
        '🧯',
        '🔬',
        '🕳',
        '💊',
        '💉',
        '🌡',
        '🚽',
        '🚰',
        '🚿',
        '🛁',
        '🛀',
        '🧴',
        '🧷',
        '🧹',
        '🧺',
        '🧻',
        '🧼',
        '🧽',
        '🛎',
        '🔑',
        '🗝',
        '🚪',
        '🛋',
        '🛏',
        '🛌',
        '🖼',
        '🛍',
        '🧳',
        '🛒',
        '🎁',
        '🎈',
        '🎏',
        '🎀',
        '🎊',
        '🎉',
        '🧨',
        '🎎',
        '🏮',
        '🎐',
        '🧧',
        '✉️',
        '📩',
        '📨',
        '📧',
        '💌',
        '📥',
        '📤',
        '📦',
        '🏷',
        '📪',
        '📫',
        '📬',
        '📭',
        '📮',
        '📯',
        '📜',
        '📃',
        '📄',
        '📑',
        '📊',
        '📈',
        '📉',
        '🗒',
        '🗓',
        '📆',
        '📅',
        '📇',
        '🗃',
        '🗳',
        '🗄',
        '📋',
        '📁',
        '📂',
        '🗂',
        '🗞',
        '📰',
        '📓',
        '📔',
        '📒',
        '📘',
        '📙',
        '📚',
        '📖',
        '🔖',
        '🔗',
        '📎',
        '🖇',
        '📐',
        '📏',
        '📌',
        '📍',
        '✂️',
        '🖊',
        '🖋',
        '✒️',
        '🖌',
        '🖍',
        '📝',
        '✏️',
        '🔍',
        '🔎',
        '🔏',
        '🔐',
        '🔒',
        '🔓',
        '❤️',
        '🧡',
        '💛',
        '💚',
        '💙',
        '💜',
        '🖤',
        '💔',
        '❣️',
        '💕',
        '💞',
        '💓',
        '💗',
        '💖',
        '💘',
        '💝',
        '💟',
        '☮️',
        '✝️',
        '☪️',
        '🕉',
        '☸️',
        '✡️',
        '🔯',
        '🕎',
        '☯️',
        '☦️',
        '🛐',
        '⛎',
        '♈️',
        '♉️',
        '♊️',
        '♋️',
        '♌️',
        '♍️',
        '♎️',
        '♏️',
        '♐️',
        '♑️',
        '♒️',
        '♓️',
        '🆔',
        '⚛️',
        '🉑',
        '☢️',
        '☣️',
        '📴',
        '📳',
        '🈶',
        '🈚️',
        '🈸',
        '🈺',
        '🈷️',
        '✴️',
        '🆚',
        '💮',
        '🉐',
        '㊙️',
        '㊗️',
        '🈴',
        '🈵',
        '🈹',
        '🈲',
        '🅰️',
        '🅱️',
        '🆎',
        '🆑',
        '🅾️',
        '🆘',
        '❌',
        '⭕️',
        '🛑',
        '⛔️',
        '📛',
        '🚫',
        '💯',
        '💢',
        '♨️',
        '🚷',
        '🚯',
        '🚳',
        '🚱',
        '🔞',
        '📵',
        '🚭',
        '❗️',
        '❕',
        '❓',
        '❔',
        '‼️',
        '⁉️',
        '🔅',
        '🔆',
        '〽️',
        '⚠️',
        '🚸',
        '🔱',
        '⚜️',
        '🔰',
        '♻️',
        '✅',
        '🈯️',
        '💹',
        '❇️',
        '✳️',
        '❎',
        '🌐',
        '💠',
        'Ⓜ️',
        '🌀',
        '💤',
        '🏧',
        '🚾',
        '♿️',
        '🅿️',
        '🈳',
        '🈂️',
        '🛂',
        '🛃',
        '🛄',
        '🛅',
        '🚹',
        '🚺',
        '🚼',
        '🚻',
        '🚮',
        '🎦',
        '📶',
        '🈁',
        '🔣',
        'ℹ️',
        '🔤',
        '🔡',
        '🔠',
        '🆖',
        '🆗',
        '🆙',
        '🆒',
        '🆕',
        '0️⃣',
        '1️⃣',
        '2️⃣',
        '3️⃣',
        '4️⃣',
        '5️⃣',
        '6️⃣',
        '7️⃣',
        '8️⃣',
        '9️⃣',
        '🔟',
        '🔢',
        '#️⃣',
        '*️⃣',
        '⏏️',
        '▶️',
        '⏸',
        '⏯',
        '⏹',
        '⏺',
        '⏭',
        '⏮',
        '⏩',
        '⏪',
        '⏫',
        '⏬',
        '◀️',
        '🔼',
        '🔽',
        '➡️',
        '⬅️',
        '⬆️',
        '⬇️',
        '↗️',
        '↘️',
        '↙️',
        '↖️',
        '↕️',
        '↔️',
        '↪️',
        '↩️',
        '⤴️',
        '⤵️',
        '🔀',
        '🔁',
        '🔂',
        '🔄',
        '🔃',
        '🎵',
        '🎶',
        '➕',
        '➖',
        '➗',
        '✖️',
        '♾',
        '💲',
        '💱',
        '™️',
        '©️',
        '®️',
        '〰️',
        '➰',
        '➿',
        '🔚',
        '🔙',
        '🔛',
        '🔝',
        '🔜',
        '✔️',
        '☑️',
        '🔘',
        '⚪️',
        '⚫️',
        '🔴',
        '🔵',
        '🔺',
        '🔻',
        '🔸',
        '🔹',
        '🔶',
        '🔷',
        '🔳',
        '🔲',
        '▪️',
        '▫️',
        '◾️',
        '◽️',
        '◼️',
        '◻️',
        '⬛️',
        '⬜️',
        '🔈',
        '🔇',
        '🔉',
        '🔊',
        '🔔',
        '🔕',
        '📣',
        '📢',
        '👁‍🗨',
        '💬',
        '💭',
        '🗯',
        '♠️',
        '♣️',
        '♥️',
        '♦️',
        '🃏',
        '🎴',
        '🀄️',
        '🕐',
        '🕑',
        '🕒',
        '🕓',
        '🕔',
        '🕕',
        '🕖',
        '🕗',
        '🕘',
        '🕙',
        '🕚',
        '🕛',
        '🕜',
        '🕝',
        '🕞',
        '🕟',
        '🕠',
        '🕡',
        '🕢',
        '🕣',
        '🕤',
        '🕥',
        '🕦',
        '🕧',
        '🏳️',
        '🏴',
        '🏁',
        '🚩',
        '🏳️‍🌈',
        '🏴‍☠️',
        '🇦🇫',
        '🇦🇽',
        '🇦🇱',
        '🇩🇿',
        '🇦🇸',
        '🇦🇩',
        '🇦🇴',
        '🇦🇮',
        '🇦🇶',
        '🇦🇬',
        '🇦🇷',
        '🇦🇲',
        '🇦🇼',
        '🇦🇺',
        '🇦🇹',
        '🇦🇿',
        '🇧🇸',
        '🇧🇭',
        '🇧🇩',
        '🇧🇧',
        '🇧🇾',
        '🇧🇪',
        '🇧🇿',
        '🇧🇯',
        '🇧🇲',
        '🇧🇹',
        '🇧🇴',
        '🇧🇦',
        '🇧🇼',
        '🇧🇷',
        '🇮🇴',
        '🇻🇬',
        '🇧🇳',
        '🇧🇬',
        '🇧🇫',
        '🇧🇮',
        '🇰🇭',
        '🇨🇲',
        '🇨🇦',
        '🇮🇨',
        '🇨🇻',
        '🇧🇶',
        '🇰🇾',
        '🇨🇫',
        '🇹🇩',
        '🇨🇱',
        '🇨🇳',
        '🇨🇽',
        '🇨🇨',
        '🇨🇴',
        '🇰🇲',
        '🇨🇬',
        '🇨🇩',
        '🇨🇰',
        '🇨🇷',
        '🇨🇮',
        '🇭🇷',
        '🇨🇺',
        '🇨🇼',
        '🇨🇾',
        '🇨🇿',
        '🇩🇰',
        '🇩🇯',
        '🇩🇲',
        '🇩🇴',
        '🇪🇨',
        '🇪🇬',
        '🇸🇻',
        '🇬🇶',
        '🇪🇷',
        '🇪🇪',
        '🇪🇹',
        '🇪🇺',
        '🇫🇰',
        '🇫🇴',
        '🇫🇯',
        '🇫🇮',
        '🇫🇷',
        '🇬🇫',
        '🇵🇫',
        '🇹🇫',
        '🇬🇦',
        '🇬🇲',
        '🇬🇪',
        '🇩🇪',
        '🇬🇭',
        '🇬🇮',
        '🇬🇷',
        '🇬🇱',
        '🇬🇩',
        '🇬🇵',
        '🇬🇺',
        '🇬🇹',
        '🇬🇬',
        '🇬🇳',
        '🇬🇼',
        '🇬🇾',
        '🇭🇹',
        '🇭🇳',
        '🇭🇰',
        '🇭🇺',
        '🇮🇸',
        '🇮🇳',
        '🇮🇩',
        '🇮🇷',
        '🇮🇶',
        '🇮🇪',
        '🇮🇲',
        '🇮🇱',
        '🇮🇹',
        '🇯🇲',
        '🇯🇵',
        '🎌',
        '🇯🇪',
        '🇯🇴',
        '🇰🇿',
        '🇰🇪',
        '🇰🇮',
        '🇽🇰',
        '🇰🇼',
        '🇰🇬',
        '🇱🇦',
        '🇱🇻',
        '🇱🇧',
        '🇱🇸',
        '🇱🇷',
        '🇱🇾',
        '🇱🇮',
        '🇱🇹',
        '🇱🇺',
        '🇲🇴',
        '🇲🇰',
        '🇲🇬',
        '🇲🇼',
        '🇲🇾',
        '🇲🇻',
        '🇲🇱',
        '🇲🇹',
        '🇲🇭',
        '🇲🇶',
        '🇲🇷',
        '🇲🇺',
        '🇾🇹',
        '🇲🇽',
        '🇫🇲',
        '🇲🇩',
        '🇲🇨',
        '🇲🇳',
        '🇲🇪',
        '🇲🇸',
        '🇲🇦',
        '🇲🇿',
        '🇲🇲',
        '🇳🇦',
        '🇳🇷',
        '🇳🇵',
        '🇳🇱',
        '🇳🇨',
        '🇳🇿',
        '🇳🇮',
        '🇳🇪',
        '🇳🇬',
        '🇳🇺',
        '🇳🇫',
        '🇰🇵',
        '🇲🇵',
        '🇳🇴',
        '🇴🇲',
        '🇵🇰',
        '🇵🇼',
        '🇵🇸',
        '🇵🇦',
        '🇵🇬',
        '🇵🇾',
        '🇵🇪',
        '🇵🇭',
        '🇵🇳',
        '🇵🇱',
        '🇵🇹',
        '🇵🇷',
        '🇶🇦',
        '🇷🇪',
        '🇷🇴',
        '🇷🇺',
        '🇷🇼',
        '🇼🇸',
        '🇸🇲',
        '🇸🇦',
        '🇸🇳',
        '🇷🇸',
        '🇸🇨',
        '🇸🇱',
        '🇸🇬',
        '🇸🇽',
        '🇸🇰',
        '🇸🇮',
        '🇬🇸',
        '🇸🇧',
        '🇸🇴',
        '🇿🇦',
        '🇰🇷',
        '🇸🇸',
        '🇪🇸',
        '🇱🇰',
        '🇧🇱',
        '🇸🇭',
        '🇰🇳',
        '🇱🇨',
        '🇵🇲',
        '🇻🇨',
        '🇸🇩',
        '🇸🇷',
        '🇸🇿',
        '🇸🇪',
        '🇨🇭',
        '🇸🇾',
        '🇹🇼',
        '🇹🇯',
        '🇹🇿',
        '🇹🇭',
        '🇹🇱',
        '🇹🇬',
        '🇹🇰',
        '🇹🇴',
        '🇹🇹',
        '🇹🇳',
        '🇹🇷',
        '🇹🇲',
        '🇹🇨',
        '🇹🇻',
        '🇻🇮',
        '🇺🇬',
        '🇺🇦',
        '🇦🇪',
        '🇬🇧',
        '🇺🇳',
        '🇺🇸',
        '🇺🇾',
        '🇺🇿',
        '🇻🇺',
        '🇻🇦',
        '🇻🇪',
        '🇻🇳',
        '🇼🇫',
        '🇪🇭',
        '🇾🇪',
        '🇿🇲',
        '🇿🇼',
        '🦸',
        '🦹',
        '🦞',
        '🧁',
        '🧮',
        '☺',
        '☹',
        '☠',
        '👾',
        '🎃',
        '✌',
        '☝',
        '✍',
        '👯',
        '☘',
        '⭐',
        '⚡',
        '☄',
        '☀',
        '⛅',
        '☁',
        '❄',
        '☃',
        '⛄',
        '☔',
        '☂',
        '☕',
        '⚽',
        '⚾',
        '⛳',
        '♟️',
        '✈',
        '⛵',
        '⚓',
        '⛽',
        '⛲',
        '⛺',
        '⛪',
        '⌚',
        '⌨',
        '☎',
        '⌛',
        '⚖',
        '⚙',
        '⚔',
        '⚰',
        '⚱',
        '⚗',
        '✉',
        '✂',
        '✒',
        '✏',
        '❤',
        '❣',
        '☮',
        '✝',
        '☪',
        '☸',
        '✡',
        '☯',
        '☦',
        '♈',
        '♉',
        '♊',
        '♋',
        '♌',
        '♍',
        '♎',
        '♏',
        '♐',
        '♑',
        '♒',
        '♓',
        '⚛',
        '☢',
        '☣',
        '🈚',
        '🈷',
        '✴',
        '㊙',
        '㊗',
        '🅰',
        '🅱',
        '🅾',
        '⭕',
        '⛔',
        '♨',
        '❗',
        '‼',
        '⁉',
        '〽',
        '⚠',
        '⚜',
        '♻',
        '🈯',
        '❇',
        '✳',
        'Ⓜ',
        '♿',
        '🅿',
        '🈂',
        'ℹ',
        '⏏',
        '▶',
        '◀',
        '➡',
        '⬅',
        '⬆',
        '⬇',
        '↗',
        '↘',
        '↙',
        '↖',
        '↕',
        '↔',
        '↪',
        '↩',
        '⤴',
        '⤵',
        '✖',
        '♾️',
        '™',
        '©',
        '®',
        '〰',
        '✔',
        '☑',
        '⚪',
        '⚫',
        '▪',
        '▫',
        '◾',
        '◽',
        '◼',
        '◻',
        '⬛',
        '⬜',
        '🗨',
        '👁️‍🗨️',
        '♠',
        '♣',
        '♥',
        '♦',
        '🀄',
        '🏳',
        '🇸🇹',
        '🇦🇨',
        '🇧🇻',
        '🇨🇵',
        '🇪🇦',
        '🇩🇬',
        '🇭🇲',
        '🇲🇫',
        '🇸🇯',
        '🇹🇦',
        '🇺🇲',
        '♀',
        '♂',
        '⚕',
        '0',
        '1',
        '2',
        '3',
        '4',
        '5',
        '6',
        '7',
        '8',
        '9',
        '#',
        '*',
        '🤼',
        '🧙',
        '🧝',
        '🧛',
        '🧟',
        '🧞',
        '🧜',
        '🧚',
        '🧖',
        '👩‍❤️‍👨',
        '👩‍❤️‍💋‍👨',
        '👨‍👩‍👦',
        '🦱',
        '🦰',
        '🇿',
        '🇾',
        '🇽',
        '🇼',
        '🇻',
        '🇺',
        '🇹',
        '🇸',
        '🇷',
        '🇶',
        '🇵',
        '🇴',
        '🇳',
        '🇲',
        '🇱',
        '🇰',
        '🇯',
        '🇮',
        '🇭',
        '🇬',
        '🇫',
        '🇪',
        '🇩',
        '🇨',
        '🇧',
        '🇦',
        '🦳',
        '🦲',
        '🏻',
        '🏼',
        '🏽',
        '🏾',
        '🏿',
    ];

    /**
     * Allow Persistent Definitions to set a different value
     *
     * @param array<string, mixed> $persisted_data
     */
    public function setPersistedData(array $persisted_data): void
    {
        // The first time there will be no persisted data
        if ($counters = $persisted_data['counters']) {
            $this->definition_counters = $counters;
        }
    }
    /**
     * @return array<string, mixed>
     */
    public function getDataToPersist(): array
    {
        return array(
            'counters' => $this->definition_counters,
        );
    }

    public function getDefinition(string $name, string $group): string
    {
        if (!$this->definition_counters[$group]) {
            $this->definition_counters[$group] = 0;
        }

        // There are 1819 emojis, and more modules than that. Then, add a 2nd emoji character when needed
        $quotient = intdiv($this->definition_counters[$group], count($this->emojis));
        $pre = '';
        if ($quotient > -1) {
            $pre = $this->emojis[$quotient];
        }

        // Get the emoji
        $emoji = $this->emojis[$this->definition_counters[$group] % count($this->emojis)];

        // Increase the counter by 1.
        $this->definition_counters[$group] = $this->definition_counters[$group] + 1;

        // That's it, return the result
        return $pre . $emoji;
    }
}
